/*
  Copyright (C) 2012  Philipp Kaelin

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "ApplicationState.h"
#include "Hardware.h"

//=============================================================================
// Bereit
//=============================================================================
void StateBereit::entryAction() {
  Led::ready(true);
}

//-----------------------------------------------------------------------------
void StateBereit::exitAction() {
  Led::ready(false);
}

//-----------------------------------------------------------------------------
void StateBereit::tickAction() { }

//=============================================================================
// Toast einziehen
//=============================================================================
void StateToastEinziehen::entryAction() {
  // Toast wird gerade eingezogen. Warte auf Endschalter drinnen
  //   --> Motor linkslauf
  Motor::left();
}

//-----------------------------------------------------------------------------
void StateToastEinziehen::exitAction() {
  //   --> Motor aus
  Motor::stop();
}

//-----------------------------------------------------------------------------
void StateToastEinziehen::tickAction() { }

//=============================================================================
// Toast auswerfen
//=============================================================================
void StateToastAuswerfen::entryAction() {
  // Toast wird gerade ausgeworfen. Warte auf Endschalter leer
  //    --> Motor rechtslauf
  Motor::right();
}

//-----------------------------------------------------------------------------
void StateToastAuswerfen::exitAction() {
  //    --> Motor aus
  Motor::stop();
}

//-----------------------------------------------------------------------------
void StateToastAuswerfen::tickAction() { }

//=============================================================================
// Toasten
//=============================================================================
void StateToasten::entryAction() {
  // Dem Toast wird gerade so richtig eingeheizt
  //    --> Heizung ein
  toastTime = 0;
  Heating::heat(true);
  Led::heating(true);
}

//-----------------------------------------------------------------------------
void StateToasten::exitAction() {
  //   --> Heizung aus
  Heating::heat(false);
  Led::heating(false);
}

//-----------------------------------------------------------------------------
void StateToasten::tickAction() {
  toastTime++;
}

//=============================================================================
// StateFehler
//=============================================================================
void StateFehler::entryAction() {
  Led::error(true);
}

//-----------------------------------------------------------------------------
void StateFehler::exitAction() {
  Led::error(false);
}

//-----------------------------------------------------------------------------
void StateFehler::tickAction() { }
